<?php

namespace Arma;

/**
 * Dense matrix.
 *
 * @package Arma
 */
abstract class Mat implements Internal\DenseResizableMatrix
{
    /**
     * Construct the matrix to have user specified dimensions and fill with specified pattern.
     *
     * @param int $n_rows[optional]
     * @param int $n_cols[optional]
     * @param int $fill[optional]
     * @return Mat
     */
    static function init($n_rows, $n_cols, $fill) {
        return new static;
    }

    /**
     * Create the matrix from a textual description.
     *
     * @param string $text
     * @return Mat
     */
    static function fromString($text) {
        return new static;
    }

    /**
     * Create the matrix from a PHP array.
     *
     * @param array $arr
     * @return Mat
     */
    static function fromArray($arr) {
        return new static;
    }
}
