<?php

namespace Arma;

/**
 * Row vector.
 *
 * @package Arma
 */
abstract class Row implements Internal\DenseResizableVector
{
    /**
     * At the given column index, insert given number of empty columns and optionally specify
     * whether to initialize new elements to zero, or insert a copy of specified object
     * (whose row size is the same as the recipient object),
     *
     * @param int                $col_idx
     * @param Internal\Dense|int $cols
     * @param bool               $set_to_zero[optional]
     * @return void
     */
    function insertCols($col_idx, $cols, $set_to_zero = true) {}

    /**
     * Remove the specified range of columns from the row vector.
     *
     * @param int $first_col
     * @param int $last_col
     * @return void
     */
    function shedCols($first_col, $last_col) {}

    /**
     * Swap the contents of specified columns.
     *
     * @param int $col_1
     * @param int $col_2
     * @return void
     */
    function swapCols($col_1, $col_2) {}
}
