<?php

namespace Arma\Internal;

/**
 * Interface for non-resizable dense vectors (subview).
 *
 * @package Arma\Internal
 */
interface DenseNonResizableVector extends DenseVector, NonResizableVector
{
    // Initialization

    /**
     * Set all the elements of an object to one.
     *
     * @return $this
     */
    function ones();

    /**
     * Set all the elements to random values.
     *
     * Uses a uniform distribution in the [0,1] interval.
     *
     * @return $this
     */
    function randu();

    /**
     * Set all the elements to random values.
     *
     * @return $this
     */
    function randn();
}
