<?php

namespace Arma\Internal;

use Arma\SpSvMapVal;

/**
 * Interface for resizable (non-subview) sparse matrices.
 *
 * @package Arma\Internal
 */
interface SparseNonResizableMatrix extends SparseMatrix, NonResizableMatrix
{
    // Subview

    /**
     * {@inheritdoc}
     *
     * @param int $i
     * @param int $j[optional]
     * @return SpSvMapVal
     */
    function __invoke($i, $j);

    /**
     * {@inheritdoc}
     *
     * @param int $i
     * @param int $j[optional]
     * @return SpSvMapVal
     */
    function at($i, $j);
}
