--TEST--
Test for initialization of `Mat`.
--SKIPIF--
<?php
require_once 'includes/loaded.php';
is_php_arma_loaded();
?>
--FILE--
<?php

require_once 'includes/assert.php';

$mat = Arma\DMat::init(3, 4, Arma\Fill::ZEROS);
batch_assert('initialization of `Arma\\Mat`',
    [3,     $mat->nRows()],
    [4,     $mat->nCols()],
    [3 * 4, $mat->nElem()],
    [0.,    $mat->max()],
    [0.,    $mat->min()]
);

$mat1 = Arma\IMat::fromString('1 2; 3 4');
batch_assert('initialization from string of `Arma\\Mat`',
    [2,     $mat1->nRows()],
    [2,     $mat1->nCols()],
    [2 * 2, $mat1->nElem()],
    [1,     $mat1(0, 0)->val()],
    [2,     $mat1(0, 1)->val()],
    [3,     $mat1(1, 0)->val()],
    [4,     $mat1(1, 1)->val()]
);

$mat2 = Arma\IMat::fromArray([
    [1, 2],
    [3, 4]
]);
batch_assert('initialization from array of `Arma\\Mat`',
    [2,     $mat2->nRows()],
    [2,     $mat2->nCols()],
    [2 * 2, $mat2->nElem()],
    [1,     $mat2(0, 0)->val()],
    [2,     $mat2(0, 1)->val()],
    [3,     $mat2(1, 0)->val()],
    [4,     $mat2(1, 1)->val()]
);

?>
--EXPECT--
